package io.scanbot.sdk.reactnative.models

import com.facebook.react.bridge.WritableMap
import com.facebook.react.uimanager.events.Event

interface BaseEvent {
    val eventName: String
    fun parseData(): WritableMap
}

class ComponentEvent(private val baseEvent: BaseEvent, surfaceId: Int, viewTag: Int) :
    Event<ComponentEvent>(surfaceId, viewTag) {

    override fun getEventData(): WritableMap {
        return baseEvent.parseData()
    }

    override fun getEventName(): String {
        return baseEvent.eventName
    }

    override fun canCoalesce(): Boolean {
        return false
    }
}
